(ns com.aurellem.run.choreo
  (:use (com.aurellem.gb saves gb-driver util constants
                         items vbm characters money
                         rlm-assembly))
  (:use (com.aurellem.run util music title save-corruption
                          bootstrap-0 bootstrap-1 image
                          ram-display))
  (:require clojure.string)
  (:import [com.aurellem.gb.gb_driver SaveState])
  (:import java.io.File))



;; take over game
;; [X] silence noise
;; [ ] construct writing/playing kernel
;; [ ] play pony song while writing picture-program
;; [ ] run picture program to display pinkie pie mark



(defn-memo silence-noise
  ([] (silence-noise (launch-main-bootstrap-program)))
  ([script]
     (->> script
          (write-RAM 0xFF1A [0 0 0]))))


(defn-memo write-pony-music-data
  ([] (write-pony-music-data (launch-main-bootstrap-program)))
  ([script]
     (let [bytes (midi-bytes pony-csv)]
       (->> script
            (do-nothing 10)
            (write-RAM (:address (:voice-1 bytes))
                       (:data    (:voice-1 bytes)))

            (do-nothing 100)
            (write-RAM (:address (:voice-2 bytes))
                       (:data    (:voice-2 bytes)))

            (do-nothing 100)
            (write-RAM (:address (:noise bytes))
                       (:data    (:noise bytes)))

            (do-nothing 100)
            (write-RAM (:address (:kernel bytes))
                       (:data    (:kernel bytes)))
            (transfer-control (:address (:kernel bytes)))))))



